// Pang1.cpp: implementation of the CPang class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "pang.h"
#include "Pang1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPang::CPang()
{
	running = false;
}

CPang::~CPang()
{

}

void CPang::RunOnce()
{
	if (running)
	{
		balloon1.Move();
		fire1.Update();
		if (fire1.GetFired() && CheckCollision(&balloon1, &fire1))
		{
			running = false;
			balloon1.Collided();
			fire1.Collided();
			AfxMessageBox("You win");
		}
		if (CheckCollision(&player1, &balloon1))
		{
			running = false;
			AfxMessageBox("You lose");
		}
	}
}

void CPang::Draw(CPaintDC &dc)
{
	if (running)
	{
		player1.Draw(dc);
		balloon1.Draw(dc);
		fire1.Draw(dc);
	}
}

void CPang::Start()
{
	balloon1.Initialize();
	fire1.Initialize();
	player1.Initialize();
	running = true;
}

void CPang::Stop()
{
	running = false;
}

bool CPang::GetRunning()
{
	return running;
}

void CPang::MovePlayerLeft()
{
	player1.MoveLeft();
}

void CPang::MovePlayerRight()
{
	player1.MoveRight();
}

void CPang::Fire()
{
	if (!fire1.GetFired())
		fire1.Fire(player1.GetPosition());
}

bool CPang::CheckCollision(CPlayer *obj1, CBalloon *obj2)
{
	int points1[4];
	int points2[4];
	obj1->GetRectCoords(points1);
	obj2->GetRectCoords(points2);
	CRgn rgn;
	rgn.CreateRectRgn(points2[0], points2[1], points2[2], points2[3]);
	
	if (rgn.PtInRegion(points1[0], points1[1]))
		return true;
	if (rgn.PtInRegion(points1[0], points1[3]))
		return true;
	if (rgn.PtInRegion(points1[2], points1[1]))
		return true;
	if (rgn.PtInRegion(points1[2], points1[3]))
		return true;
	
	int midx = points1[0] + ((points1[2] - points1[0])/2);
	int midy = points1[1] + ((points1[3] - points1[1])/2);
	if (rgn.PtInRegion(midx, midy))
		return true;

	return false;
}

bool CPang::CheckCollision(CBalloon *obj1, CFire *obj2)
{
	int points1[4];
	int points2[4];
	obj1->GetRectCoords(points1);
	obj2->GetRectCoords(points2);
	CRgn rgn;
	rgn.CreateRectRgn(points2[0], points2[1], points2[2], points2[3]);
	
	if (rgn.PtInRegion(points1[0], points1[1]))
		return true;
	if (rgn.PtInRegion(points1[0], points1[3]))
		return true;
	if (rgn.PtInRegion(points1[2], points1[1]))
		return true;
	if (rgn.PtInRegion(points1[2], points1[3]))
		return true;
	
	int midx = points1[0] + ((points1[2] - points1[0])/2);
	int midy = points1[1] + ((points1[3] - points1[1])/2);
	if (rgn.PtInRegion(midx, midy))
		return true;

	return false;
}
